#!/bin/bash
# Данный скрипт необходим для закрепления в системе всех имеющихся на данный момент пакетов.
# Рекоммендуется использовать 1 раз для установки базовой конфигурации.
#
# Например, установил я систему Debian Niaga, удалил ненужный мне софт и поставил всё необходимое.
# После этого запускаем данный скрипт и получаем файл exclude_minimal.lst, наличие которого
# не позволит снести из системы базовые пакеты.
#
# Все остальные пакеты должны быть добавлены вручную в файл exclude_hand.lst,

fname=exclude_base.lst

if [ -e $fname ]; then
    echo "Базовая установка была сделана ранее!"
    echo "Файл $fname переписан не будет."
    exit 1
fi

{
echo "!!! WARNING !!!"
echo "    /"
echo "   /_"
echo "    /"
echo "   V"
echo 'DO NOT EDIT MANUALY ! USE mkbaselist.sh'
echo
dpkg -l|grep ii |cut -d ' ' -f3
} >$fname

echo "Файл $fname создан успешно."
echo "=) OK ! =)"

exit 0

