#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>

#include "netfuncs.h"

int sendall(int s, char *buf, int len, int flags)
{
	int total = 0;
	int n;

	while (total < len) {
		n = send(s, buf + total, len - total, flags);
		if (n == -1) {
			break;
		}
		total += n;
	}

	return (n == -1 ? -1 : total);
}

char message[] = "Hello there!\n";
char buf[sizeof(message)];

int main()
{
	int sock;
	struct sockaddr_in addr;

	sock = socket(AF_INET, SOCK_STREAM, 0);
	if (sock < 0) {
		perror("socket");
		exit(1);
	}

	addr.sin_family = AF_INET;
	addr.sin_port = htons(3425);	// или любой другой порт...
	addr.sin_addr.s_addr = htonl(INADDR_LOOPBACK);	// (ip2int("192.168.2.1"));
	if (connect(sock, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
		perror("connect");
		exit(2);
	}

	send(sock, message, sizeof(message), 0);

	memset(buf, sizeof(message), 0);

	recv(sock, buf, sizeof(message), 0);

	printf("%s\n", buf);
	close(sock);

	return 0;
}
